VirtualBox Main API

Public Attributes | List of all members
IUSBDevice Interface Reference

The IUSBDevice interface represents a virtual USB device attached to the virtual machine. More...

Inheritance diagram for IUSBDevice:

## Public Attributes
readonly attribute wstringUUID | id
| Unique USB device ID. More...
readonly attribute unsigned short | vendorId
| Vendor ID. More...
readonly attribute unsigned short | productId
| Product ID. More...
readonly attribute unsigned short | revision
| Product revision number. More...
readonly attribute wstring | manufacturer
| Manufacturer string. More...
readonly attribute wstring | product
| Product string. More...
readonly attribute wstring | serialNumber
| Serial number string. More...
readonly attribute wstring | address
| Host specific address of the device. More...
readonly attribute unsigned short | port
| Host USB port number the device is physically connected to. More...
readonly attribute unsigned short | version
| The major USB version of the device - 1, 2 or 3. More...
readonly attribute unsigned short | portVersion
| The major USB version of the host USB port the device is physically connected to - 1, 2 or 3. More...
readonly attribute USBConnectionSpeed | speed
| The speed at which the device is currently communicating. More...
readonly attribute boolean | remote
| Whether the device is physically connected to a remote VRDE client or to a local host machine. More...
readonly attribute wstring [] | deviceInfo
| Array of device attributes as single strings. More...
readonly attribute wstring | backend
| The backend which will be used to communicate with this device. More...

## Detailed Description

The IUSBDevice interface represents a virtual USB device attached to the virtual machine.

A collection of objects implementing this interface is stored in the IConsole::USBDevices attribute which lists all USB devices attached to a running virtual machine's USB controller.

Interface ID:
  `{5915D179-83C7-4F2B-A323-9A97F46F4E29}`

## Member Data Documentation

## ◆ id

readonly attribute wstringUUID IUSBDevice::id

Unique USB device ID.

This ID is built from vendorId, productId, revision and serialNumber.

## ◆ vendorId

readonly attribute unsigned short IUSBDevice::vendorId

Vendor ID.

## ◆ productId

readonly attribute unsigned short IUSBDevice::productId

Product ID.

## ◆ revision

readonly attribute unsigned short IUSBDevice::revision

Product revision number.

This is a packed BCD represented as unsigned short. The high byte is the integer part and the low byte is the decimal.

## ◆ manufacturer

readonly attribute wstring IUSBDevice::manufacturer

Manufacturer string.

## ◆ product

readonly attribute wstring IUSBDevice::product

Product string.

## ◆ serialNumber

readonly attribute wstring IUSBDevice::serialNumber

Serial number string.

## ◆ address

readonly attribute wstring IUSBDevice::address

Host specific address of the device.

## ◆ port

readonly attribute unsigned short IUSBDevice::port

Host USB port number the device is physically connected to.

## ◆ version

readonly attribute unsigned short IUSBDevice::version

The major USB version of the device - 1, 2 or 3.

## ◆ portVersion

readonly attribute unsigned short IUSBDevice::portVersion

The major USB version of the host USB port the device is physically connected to - 1, 2 or 3.

For devices not connected to anything this will have the same value as the version attribute.

## ◆ speed

readonly attribute USBConnectionSpeed IUSBDevice::speed

The speed at which the device is currently communicating.

## ◆ remote

readonly attribute boolean IUSBDevice::remote

Whether the device is physically connected to a remote VRDE client or to a local host machine.

## ◆ deviceInfo

readonly attribute wstring [] IUSBDevice::deviceInfo

Array of device attributes as single strings.

So far the following are used: 0: The manufacturer string, if the device doesn't expose the ID one is taken from an internal database or an empty string if none is found. 1: The product string, if the device doesn't expose the ID one is taken from an internal database or an empty string if none is found.

## ◆ backend

readonly attribute wstring IUSBDevice::backend

The backend which will be used to communicate with this device.